/*
 Bytes and words, oh my.  
 Released into the public domain.
 */

#ifndef DEFS_ONCE
#define DEFS_ONCE

#define PATHNAME_MAX 1024

typedef unsigned char byte;
typedef unsigned short int word;
typedef unsigned long int dword;

#define READ_LE_DWORD(ptr) ((*(byte *)((ptr)+3)<<24)|\
                    (*(byte *)((ptr)+2)<<16)|\
                    (*(byte *)((ptr)+1)<<8)|\
                    (*(byte *)((ptr)+0)))
#define READ_LE_WORD(ptr) \
	(((*(byte *)(ptr)))|(*(byte *)((ptr)+1)<<8))

#define READ_BE_DWORD(ptr) \
    (((*(byte *)(ptr))<<24)|(*(byte *)((ptr)+1)<<16)|\
         (*(byte *)((ptr)+2)<<8)|(*(byte *)((ptr)+3)))

#define READ_BE_WORD(ptr) \
            ((*(byte *)(ptr)<<8)|(*(byte *)((ptr)+1)))

#define WRITE_BE_DWORD(p,x) \
                       ( *((p)+0)=(byte )(((x)>>24)&0xff),\
                         *((p)+1)=(byte )(((x)>>16)&0xff), \
                         *((p)+2)=(byte )(((x)>>8)&0xff),\
                         *((p)+3)=(byte )(((x)>>0)&0xff) )
#define WRITE_BE_WORD(p,x) \
                       ( *((p)+0)=(byte )(((x)>>8)&0xff), \
                         *((p)+1)=(byte )(((x)>>0)&0xff)  )

#endif
