/*
 Simple FAT12 code
 Header
 */
#ifndef FAT_ONCE
#define FAT_ONCE

#include "defs.h"
static dword fats_magic = 0x46415453;
typedef struct fatso
{
    dword magic;
    int fd;
   
    byte * fat;

    /* DOS boot sector information */
    int BytsPerSec;
    int SecPerClus;
    int RsvdSecCnt;
    int NumFATs;
    int RootEntCnt;
    unsigned int FATSz16;

    /* Further fields from spec */
    int RootDirSectors;
    int FirstDataSector;
    int CountOfClusters;

} fatso;

static dword fdir_magic = 0xffaadd00;
typedef struct fatdir
{
    dword magic;
    fatso * ft;
    int sector;
    int size;
    char buf[1];
} fatdir;

typedef struct fatentry
{
    byte name[13];
    byte attributes;
    dword cluster;
    dword size;
} fatentry;

int fat_birth(fatso * ft, char * fname);
void fat_death(fatso * ft);

fatdir * fat_directory(fatso *, fatentry *);
int fat_entry(fatdir *, int, fatentry *);
byte * fat_file(fatso *, fatentry *);

#endif
