/*
 Routines to handle REB1200 Prefs format
 This code is released into the public domain
 */
#include "defs.h"

/*
 Header

 00 01 P R E F | DWORD ? | DWORD Offset To Pref |

 Each Pref:

 WORD ? | DWORD Offset | DWORD Len | WORD namelen | BYTES name 
 */

int read_pref_string(byte * prefp, byte * name, byte * buf, int buflen)
{
    dword filesize, prefoffset, preflen, namelen, len;
    byte  * p, * q;
    
    if (!prefp) return -1;
    filesize = *(dword *)prefp;
    len = strlen(name);

    p = prefp + sizeof(dword);
    q = p + filesize;
    p += READ_BE_DWORD(p + 10);
    while ((p+18) < q) {
        prefoffset = READ_BE_DWORD(p + 6);
        preflen = READ_BE_DWORD(p + 2);
        namelen = READ_BE_WORD(p + 10);
        p = p + 12;
        if ((p + namelen) > q) break;
/*
        printf("%.*s(%d) at %08lx %08lx (%.*s)\n",
            namelen, p, strncmp(name,p,len), prefoffset, preflen, preflen, 
            prefp + sizeof(dword) + prefoffset);
*/
        if ((len == namelen) && (strncmp(name, p, len) == 0)) {
            if ((prefoffset + preflen) > filesize) break;
            if (buflen < preflen) return preflen;
            memcpy(buf, prefp+sizeof(dword)+prefoffset,preflen);
            if (buflen > preflen) buf[preflen] = '\0';
            return 0;
        }
        p += namelen;
    }
    return -1;
}
